module Swap.Unsafe where


import System.IO.Unsafe
import Swap.Var
import App


env
  :: Var Int -> IORef Int
env
  = unsafePerformIO newEnv


ask
  :: Var Int -> IO ()
ask x
  = do
      putStr ("Input the initial value of " ++ show x ++ ": ")
      s <- getLine
      env # writeVar x (read s :: Int) 

echo
  :: Var Int -> IO ()
echo x
  = do
      val <- env # readVar x
      putStrLn ("The value of variable  " ++ show x ++ "  is  " ++ show val)


swap
  :: (Var Int , Var Int) -> IO ()
swap (x , y)
  = do
      v1 <- env # readVar x
      v2 <- env # readVar y
      env # writeVar x v2
      env # writeVar y v1


test
  :: IO ()
test
  = do
      ask X
      echo X
      ask Y
      echo Y
      putStr "Now swapping ... "
      swap (X , Y)
      putStrLn "done."
      echo X
      echo Y

main
  = do
      test

