module Swap.Globals where


import Global
import Swap.Var


ask
  :: Var Int -> IO ()
ask x
  = do
      putStr ("Input the initial value of " ++ show x ++ ": ")
      s <- getLine
      writeGlobal x (read s :: Int) 

echo
  :: Var Int -> IO ()
echo x
  = do
      val <- readGlobal x
      putStrLn ("The value of variable  " ++ show x ++ "  is  " ++ show val)


swap
  :: (Var Int , Var Int) -> IO ()
swap (x , y)
  = do
      v1 <- readGlobal x
      v2 <- readGlobal y
      writeGlobal x v2
      writeGlobal y v1


test
  :: IO ()
test
  = do
      ask X
      echo X
      ask Y
      echo Y
      putStr "Now swapping ... "
      swap (X , Y)
      putStrLn "done."
      echo X
      echo Y

main
  = do
      test

