module Swap.NoGlobals where


import Swap.Var
import App


ask
  :: Var Int -> Env Int -> IO ()
ask x env
  = do
      putStr ("Input the initial value of " ++ show x ++ ": ")
      s <- getLine
      env # writeVar x (read s :: Int) 

echo
  :: Var Int -> Env Int -> IO ()
echo x env
  = do
      val <- env # readVar x
      putStrLn ("The value of variable  " ++ show x ++ "  is  " ++ show val)


swap
  :: (Var Int , Var Int) -> Env Int -> IO ()
swap (x , y) env
  = do
      v1 <- env # readVar x
      v2 <- env # readVar y
      env # writeVar x v2
      env # writeVar y v1


test
  :: IO ()
test
  = do
      env <- newEnv
      env # ask X
      env # echo X
      env # ask Y
      env # echo Y
      putStr "Now swapping ... "
      env # swap (X , Y)
      putStrLn "done."
      env # echo X
      env # echo Y

main
  = do
      test

